diff --git a/freebsd/sys/vm/vm_extern.h b/freebsd/sys/vm/vm_extern.h
index 0d17f8af..f9875c25 100644
--- a/freebsd/sys/vm/vm_extern.h
+++ b/freebsd/sys/vm/vm_extern.h
@@ -96,6 +96,18 @@ int vm_fault_quick_hold_pages(vm_map_t map, vm_offset_t addr, vm_size_t len,
     vm_prot_t prot, vm_page_t *ma, int max_count);
 int vm_fault_trap(vm_map_t map, vm_offset_t vaddr, vm_prot_t fault_type,
     int fault_flags, int *signo, int *ucode);
+#else /* __rtems__ */
+static inline int vm_fault_quick_hold_pages(vm_map_t map, vm_offset_t addr, vm_size_t len,
+    vm_prot_t prot, vm_page_t *ma, int max_count) {
+  vm_offset_t end;
+  if (len == 0)
+    return (0);
+  end = round_page(addr + len);
+  addr = trunc_page(addr);
+ if (atop(end - addr) > max_count)
+   panic("vm_fault_quick_hold_pages: count > max_count");
+ return atop(end - addr);
+}
 #endif /* __rtems__ */
 int vm_forkproc(struct thread *, struct proc *, struct thread *,
     struct vmspace *, int);
diff --git a/freebsd/sys/vm/vm_meter.c b/freebsd/sys/vm/vm_meter.c
index dfd50081..b31cdd90 100644
--- a/freebsd/sys/vm/vm_meter.c
+++ b/freebsd/sys/vm/vm_meter.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -41,7 +43,7 @@ __FBSDID("$FreeBSD$");
 #include <sys/malloc.h>
 #include <sys/mutex.h>
 #include <sys/proc.h>
-#include <sys/resource.h>
+#include <rtems/bsd/sys/resource.h>
 #include <sys/rwlock.h>
 #include <sys/sx.h>
 #include <sys/vmmeter.h>
@@ -106,6 +108,7 @@ vmcounter_startup(void)
 }
 SYSINIT(counter, SI_SUB_KMEM, SI_ORDER_FIRST, vmcounter_startup, NULL);
 
+#ifndef __rtems__
 SYSCTL_UINT(_vm, VM_V_FREE_MIN, v_free_min,
 	CTLFLAG_RW, &vm_cnt.v_free_min, 0, "Minimum low-free-pages threshold");
 SYSCTL_UINT(_vm, VM_V_FREE_TARGET, v_free_target,
@@ -559,3 +562,4 @@ vm_stats_init(void *arg __unused)
 }
 
 SYSINIT(vmstats_init, SI_SUB_VM_CONF, SI_ORDER_FIRST, vm_stats_init, NULL);
+#endif /* __rtems__ */
diff --git a/libbsd.py b/libbsd.py
index 2f56e7c6..c5f601ed 100644
--- a/libbsd.py
+++ b/libbsd.py
@@ -39,6 +39,11 @@ import builder
 # Default configuration.
 #
 _defaults = {
+    #
+    # Global defines, added to the build of all files
+    #
+    'defines': [],
+
     #
     # Compile flags
     #
@@ -162,6 +167,7 @@ class rtems(builder.Module):
         mm = self.manager
         self.addRTEMSKernelSourceFiles(
             [
+                'fs/rootfs/rootfs.c',
                 'local/bus_if.c',
                 'local/cryptodev_if.c',
                 'local/device_if.c',
@@ -181,6 +187,8 @@ class rtems(builder.Module):
                 'rtems/rtems-bsd-get-mac-address.c',
                 'rtems/rtems-bsd-get-task-priority.c',
                 'rtems/rtems-bsd-get-task-stack-size.c',
+                'rtems/rtems-bsd-libio.c',
+                'rtems/rtems-bsd-mountroot.c',
                 'rtems/rtems-bsd-syscall-api.c',
                 'rtems/rtems-kernel-assert.c',
                 'rtems/rtems-kernel-autoconf.c',
@@ -188,8 +196,11 @@ class rtems(builder.Module):
                 'rtems/rtems-kernel-bus-dma-mbuf.c',
                 'rtems/rtems-kernel-bus-root.c',
                 'rtems/rtems-kernel-cam.c',
+                'rtems/rtems-kernel-capability.c',
                 'rtems/rtems-kernel-chunk.c',
                 'rtems/rtems-kernel-delay.c',
+                'rtems/rtems-kernel-dev.c',
+                'rtems/rtems-kernel-dirent.c',
                 'rtems/rtems-kernel-epoch.c',
                 'rtems/rtems-kernel-get-file.c',
                 'rtems/rtems-kernel-init.c',
@@ -203,6 +214,7 @@ class rtems(builder.Module):
                 'rtems/rtems-kernel-muteximpl.c',
                 'rtems/rtems-kernel-nexus.c',
                 'rtems/rtems-kernel-page.c',
+                'rtems/rtems-kernel-pager.c',
                 'rtems/rtems-kernel-panic.c',
                 'rtems/rtems-kernel-pci_bus.c',
                 'rtems/rtems-kernel-pci_cfgreg.c',
@@ -215,7 +227,9 @@ class rtems(builder.Module):
                 'rtems/rtems-kernel-timesupport.c',
                 'rtems/rtems-kernel-termioskqueuepoll.c',
                 'rtems/rtems-kernel-thread.c',
+                'rtems/rtems-kernel-vfs.c',
                 'rtems/rtems-kernel-vprintf.c',
+                'rtems/rtems-kernel-vmem.c',
                 'rtems/rtems-kernel-wpa-supplicant.c',
                 'rtems/rtems-legacy-rtrequest.c',
                 'rtems/rtems-legacy-newproc.c',
@@ -242,6 +256,7 @@ class rtems(builder.Module):
                 'sys/dev/usb/controller/usb_otg_transceiver.c',
                 'sys/dev/usb/controller/usb_otg_transceiver_dump.c',
                 'sys/fs/devfs/devfs_devs.c',
+                'sys/kern/vnode_if.c',
                 'sys/net/if_ppp.c',
                 'sys/net/ppp_tty.c',
             ],
@@ -366,10 +381,13 @@ class base(builder.Module):
                 'sys/contrib/ck/include/gcc/x86/ck_f_pr.h',
                 'sys/contrib/ck/include/gcc/x86/ck_pr.h',
                 'sys/fs/devfs/devfs_int.h',
+                'sys/fs/pseudofs/pseudofs.h',
+                'sys/fs/pseudofs/pseudofs_internal.h',
                 'sys/security/audit/audit.h',
                 'sys/security/mac/mac_framework.h',
                 'sys/sys/acl.h',
                 'sys/sys/aio.h',
+                'sys/sys/bio.h',
                 'sys/sys/blist.h',
                 'sys/sys/bufobj.h',
                 'sys/sys/buf_ring.h',
@@ -427,12 +445,14 @@ class base(builder.Module):
                 'sys/sys/mount.h',
                 'sys/sys/_mutex.h',
                 'sys/sys/mutex.h',
+                'sys/sys/namei.h',
                 'sys/sys/nlist_aout.h',
                 'sys/sys/_null.h',
                 'sys/sys/nv.h',
                 'sys/sys/osd.h',
                 'sys/sys/pcpu.h',
                 'sys/sys/_pctrie.h',
+                'sys/sys/pctrie.h',
                 'sys/sys/pipe.h',
                 'sys/sys/priv.h',
                 'sys/sys/proc.h',
@@ -467,7 +487,9 @@ class base(builder.Module):
                 'sys/sys/stdint.h',
                 'sys/sys/_sx.h',
                 'sys/sys/sx.h',
+                'sys/sys/syscallsubr.h',
                 'sys/sys/sysctl.h',
+                'sys/sys/sysent.h',
                 'sys/sys/sysproto.h',
                 'sys/sys/systm.h',
                 'sys/sys/_task.h',
@@ -479,6 +501,7 @@ class base(builder.Module):
                 'sys/sys/unpcb.h',
                 'sys/sys/_unrhdr.h',
                 'sys/sys/uuid.h',
+                'sys/sys/vmem.h',
                 'sys/sys/vmmeter.h',
                 'sys/sys/vnode.h',
                 'sys/vm/uma_dbg.h',
@@ -491,14 +514,16 @@ class base(builder.Module):
         self.addKernelSpaceSourceFiles(
             [
                 'sys/contrib/ck/src/ck_epoch.c',
+                'sys/fs/deadfs/dead_vnops.c',
                 'sys/kern/init_main.c',
                 'sys/kern/kern_condvar.c',
                 'sys/kern/kern_conf.c',
+                'sys/kern/kern_descrip.c',
                 'sys/kern/kern_event.c',
                 'sys/kern/kern_hhook.c',
                 'sys/kern/kern_intr.c',
-                'sys/kern/kern_ktr.c',
                 'sys/kern/kern_khelp.c',
+                'sys/kern/kern_ktr.c',
                 'sys/kern/kern_linker.c',
                 'sys/kern/kern_mbuf.c',
                 'sys/kern/kern_mib.c',
@@ -525,6 +550,7 @@ class base(builder.Module):
                 'sys/kern/subr_kobj.c',
                 'sys/kern/subr_lock.c',
                 'sys/kern/subr_pcpu.c',
+                'sys/kern/subr_pctrie.c',
                 'sys/kern/subr_prf.c',
                 'sys/kern/subr_rman.c',
                 'sys/kern/subr_sbuf.c',
@@ -542,6 +568,21 @@ class base(builder.Module):
                 'sys/kern/uipc_sockbuf.c',
                 'sys/kern/uipc_socket.c',
                 'sys/kern/uipc_usrreq.c',
+                'sys/kern/vfs_acl.c',
+                'sys/kern/vfs_aio.c',
+                'sys/kern/vfs_bio.c',
+                'sys/kern/vfs_cache.c',
+                #'sys/kern/vfs_cluster.c',
+                'sys/kern/vfs_default.c',
+                'sys/kern/vfs_export.c',
+                #'sys/kern/vfs_extattr.c',
+                'sys/kern/vfs_hash.c',
+                'sys/kern/vfs_init.c',
+                'sys/kern/vfs_lookup.c',
+                'sys/kern/vfs_mount.c',
+                'sys/kern/vfs_subr.c',
+                'sys/kern/vfs_syscalls.c',
+                'sys/kern/vfs_vnops.c',
                 'sys/libkern/crc32.c',
                 'sys/libkern/bcd.c',
                 'sys/libkern/inet_ntoa.c',
@@ -549,8 +590,13 @@ class base(builder.Module):
                 'sys/libkern/murmur3_32.c',
                 'sys/libkern/random.c',
                 'sys/fs/devfs/devfs_vnops.c',
+                'sys/fs/pseudofs/pseudofs.c',
+                'sys/fs/pseudofs/pseudofs_fileno.c',
+                'sys/fs/pseudofs/pseudofs_vncache.c',
+                'sys/fs/pseudofs/pseudofs_vnops.c',
                 'sys/vm/uma_core.c',
                 'sys/vm/uma_dbg.c',
+                'sys/vm/vm_meter.c',
             ],
             mm.generator['source']()
         )
@@ -1465,6 +1511,7 @@ class dev_nic(builder.Module):
                 'sys/arm64/include/cpu.h',
                 'sys/arm/include/cpufunc.h',
                 'sys/i386/include/md_var.h',
+                'sys/i386/include/intr_machdep.h',
                 'sys/i386/include/cpufunc.h',
                 'sys/x86/include/intr_machdep.h',
                 'sys/x86/include/specialreg.h',
diff --git a/rtemsbsd/fs/rootfs/rootfs.c b/rtemsbsd/fs/rootfs/rootfs.c
new file mode 100644
index 00000000..d31b2c06
--- /dev/null
+++ b/rtemsbsd/fs/rootfs/rootfs.c
@@ -0,0 +1,94 @@
+/**
+ * @file
+ *
+ * @ingroup rtems_bsd_rtems
+ *
+ * @brief TODO.
+ */
+
+/*
+ * Copyright (c) 2020 Chris Johns
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <machine/rtems-bsd-kernel-space.h>
+
+#include <sys/param.h>
+#include <sys/kernel.h>
+#include <sys/mount.h>
+#include <sys/vnode.h>
+
+#include <fs/pseudofs/pseudofs.h>
+
+static struct pfs_node *rootfs_root;
+
+static int
+rootfs_attr(PFS_ATTR_ARGS, int mode)
+{
+  vap->va_mode = 0;
+  return 0;
+}
+
+static int
+rootfs_attr_all_rwx(PFS_ATTR_ARGS)
+{
+  vap->va_mode = 0777;
+  return 0;
+}
+
+int
+rtems_bsd_rootfs_mkdir(const char *name)
+{
+  struct pfs_node *dir;
+  dir = pfs_create_dir(rootfs_root, name, rootfs_attr_all_rwx,
+                       NULL, NULL, PFS_RDWR | PFS_NOWAIT);
+  if (dir == NULL)
+    return ENOENT;
+  return 0;
+}
+
+int
+rtems_bsd_rootfs_rmdir(const char *name)
+{
+  struct pfs_node *dir;
+  dir = pfs_find_node(rootfs_root, name);
+  if (dir == NULL)
+    return ENOENT;
+  return pfs_destroy(dir);
+}
+
+static int
+rootfs_init(PFS_INIT_ARGS)
+{
+  rootfs_root = pi->pi_root;
+  return 0;
+}
+
+static int
+rootfs_uninit(PFS_INIT_ARGS)
+{
+  return 0;
+}
+
+PSEUDOFS(rootfs, 1, VFCF_SYNTHETIC);
diff --git a/rtemsbsd/fs/rootfs/rootvfs.c b/rtemsbsd/fs/rootfs/rootvfs.c
new file mode 100644
index 00000000..a5489f94
--- /dev/null
+++ b/rtemsbsd/fs/rootfs/rootvfs.c
@@ -0,0 +1,656 @@
+/**
+ * @file
+ *
+ * @ingroup rtems_bsd_rtems
+ *
+ * @brief TODO.
+ */
+
+/*
+ * Copyright (c) 2020 Chris Johns
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <machine/rtems-bsd-kernel-space.h>
+
+#include <sys/param.h>
+#include <sys/kernel.h>
+#include <sys/systm.h>
+#include <sys/ctype.h>
+#include <sys/dirent.h>
+#include <sys/fcntl.h>
+#include <sys/limits.h>
+#include <sys/lock.h>
+#include <sys/malloc.h>
+#include <sys/mount.h>
+#include <sys/mutex.h>
+#include <sys/namei.h>
+#include <sys/proc.h>
+#include <sys/sbuf.h>
+#include <sys/sx.h>
+#include <sys/sysctl.h>
+#include <sys/vnode.h>
+#include <sys/systm.h>
+
+/*
+ * Debugging
+ */
+#ifdef ROOTFS_TRACE
+#define ROOTFS_TRACE(foo)                        \
+do {                                             \
+  printf("%s(): line %d: ", __func__, __LINE__); \
+  printf foo ;                                   \
+  printf("\n");                                  \
+} while (0)
+#define ROOTFS_RETURN(err)                       \
+do {                                             \
+  printf("%s(): line %d: returning %d\n",        \
+         __func__, __LINE__, err);               \
+  return (err);                                  \
+} while (0)
+#else
+#define ROOTFS_TRACE(foo) \
+  do { /* nothing */ } while (0)
+#define ROOTFS_RETURN(err) \
+  return (err)
+#endif
+
+static struct vop_vector rootfs_vnodeops;
+
+/*
+ * The nodes are the file system's data. The vnode data comes and
+ * goes depending on the state of the vnode cache.
+ */
+
+#define ROOTFS_NAMELEN (64)
+#define ROOTFS_ROOT    (1 << 0)
+
+struct rootfs_node {
+  char                rn_name[ROOTFS_NAMELEN];
+  int                 rn_flags;
+  struct rootfs_node *rn_parent;
+  struct rootfs_node *rn_children;
+  struct mtx          rn_mutex;
+  struct rootfs_node *rn_prev, *rn_next;
+};
+
+struct rootfs_vdata {
+  struct rootfs_node  *rvd_rn;
+  bool                 rvd_dead;
+  struct vnode        *rvd_vnode;
+  struct rootfs_vdata *rvd_prev, *rvd_next;
+};
+
+struct rootfs_info {
+  struct rootfs_node *ri_root;
+  struct mtx          ri_mutex;
+  struct unrhdr      *ri_unrhdr;
+};
+
+static MALLOC_DEFINE(M_ROOTFSVNCACHE, "rootfs_vncache", "rootfs vnode cache");
+
+static struct rootfs_info  *rootfs;
+static struct rootfs_vdata *rootfs_vncache;
+static struct mtx           rootfs_vncache_mutex;
+
+/*
+ * Vnode operations
+ */
+static vop_access_t       rootfs_access;
+static vop_cachedlookup_t rootfs_lookup;
+static vop_mkdir_t        rootfs_mkdir;
+static vop_rmdir_t        rootfs_rmdir;
+static vop_vptocnp_t      rootfs_vptocnp;
+
+static struct vop_vector rootfs_vnodeops = {
+  .vop_default =    &default_vnodeops,
+
+  .vop_access       = rootfs_access,
+  .vop_cachedlookup = rootfs_lookup,
+  .vop_close        = VOP_EOPNOTSUPP,
+  .vop_create       = VOP_EOPNOTSUPP,
+  .vop_getattr      = VOP_EOPNOTSUPP,
+  .vop_getextattr   = VOP_EOPNOTSUPP,
+  .vop_ioctl        = VOP_EOPNOTSUPP,
+  .vop_link         = VOP_EOPNOTSUPP,
+  .vop_lookup       = vfs_cache_lookup,
+  .vop_mkdir        = VOP_EOPNOTSUPP,
+  .vop_mknod        = VOP_EOPNOTSUPP,
+  .vop_open         = VOP_EOPNOTSUPP,
+  .vop_read         = VOP_EOPNOTSUPP,
+  .vop_readdir      = VOP_EOPNOTSUPP,
+  .vop_readlink     = VOP_EOPNOTSUPP,
+  .vop_remove       = VOP_EOPNOTSUPP,
+  .vop_rename       = VOP_EOPNOTSUPP,
+  .vop_rmdir        = rootfs_rmdir,
+  .vop_setattr      = VOP_EOPNOTSUPP,
+  .vop_symlink      = VOP_EOPNOTSUPP,
+  .vop_vptocnp      = rootfs_vptocnp,
+  .vop_write        = VOP_EOPNOTSUPP,
+};
+
+static vfs_init_t rootfs_init;
+static vfs_mount_t rootfs_mount;
+static vfs_cmount_t rootfs_cmount;
+static vfs_root_t rootfs_root;
+static vfs_statfs_t rootfs_statfs;
+static vfs_sync_t rootfs_sync;
+static vfs_uninit_t rootfs_uninit;
+static vfs_unmount_t rootfs_unmount;
+static vfs_sysctl_t rootfs_sysctl;
+static vfs_purge_t rootfs_purge;
+
+static struct vfsops rootfs_vfsops = {
+  .vfs_init    = rootfs_init,
+  .vfs_mount   = rootfs_mount,
+  .vfs_cmount  = rootfs_cmount,
+  .vfs_root    = rootfs_root,
+  .vfs_statfs  = rootfs_statfs,
+  .vfs_sync    = rootfs_sync,
+  .vfs_uninit  = rootfs_uninit,
+  .vfs_unmount = rootfs_unmount,
+  .vfs_sysctl  = rootfs_sysctl,
+  .vfs_purge   = rootfs_purge,
+};
+VFS_SET(rootfs_vfsops, rootfs, VFCF_STATIC);
+
+static void
+rootfs_assert_not_owned(struct rootfs_node *rn)
+{
+  mtx_assert(&rn->rn_mutex, MA_NOTOWNED);
+}
+
+static void
+rootfs_lock(struct rootfs_node *rn)
+{
+  mtx_lock(&rn->rn_mutex);
+}
+
+static void
+rootfs_unlock(struct rootfs_node *rn)
+{
+  mtx_unlock(&rn->rn_mutex);
+}
+
+static int
+rootfs_vncache_alloc(struct mount *mp,
+                     struct vnode **vpp,
+                     struct rootfs_node *rn)
+{
+  struct rootfs_vdata *rvd;
+  struct vnode *vp;
+  int error;
+
+  rvd = malloc(sizeof *rvd, M_ROOTFSVNCACHE, M_WAITOK);
+  rvd->rvd_next = rvd->rvd_prev = NULL;
+  error = getnewvnode("rootfs", mp, &rootfs_vnodeops, vpp);
+  if (error) {
+    free(rvd, M_ROOTFSVNCACHE);
+    return (error);
+  }
+  rvd->rvd_rn = rn;
+  (*vpp)->v_data = rvd;
+  (*vpp)->v_type = VDIR;
+  rvd->rvd_vnode = *vpp;
+  vn_lock(*vpp, LK_EXCLUSIVE | LK_RETRY);
+  VN_LOCK_AREC(*vpp);
+  error = insmntque(*vpp, mp);
+  if (error != 0) {
+    free(rvd, M_ROOTFSVNCACHE);
+    *vpp = NULLVP;
+    return (error);
+  }
+  while (true) {
+    struct rootfs_vdata *rvd2;
+    mtx_lock(&rootfs_vncache_mutex);
+    /*
+     * Other thread may race with us, creating the entry we are
+     * going to insert into the cache. Recheck after
+     * pfs_vncache_mutex is reacquired.
+     */
+    for (rvd2 = rootfs_vncache; rvd2; rvd2 = rvd2->rvd_next) {
+      if (rvd2->rvd_rn == rn && rvd2->rvd_vnode->v_mount == mp) {
+        vp = rvd2->rvd_vnode;
+        VI_LOCK(vp);
+        mtx_unlock(&rootfs_vncache_mutex);
+        if (vget(vp, LK_EXCLUSIVE | LK_INTERLOCK, curthread) == 0) {
+          vgone(*vpp);
+          vput(*vpp);
+          *vpp = vp;
+          cache_purge(vp);
+          return (0);
+        }
+	continue;
+      }
+    }
+    break;
+  }
+  rvd->rvd_prev = NULL;
+  rvd->rvd_next = rootfs_vncache;
+  if (rvd->rvd_next)
+    rvd->rvd_next->rvd_prev = rvd;
+  rootfs_vncache = rvd;
+  mtx_unlock(&rootfs_vncache_mutex);
+  return (0);
+}
+
+int
+pfs_vncache_free(struct vnode *vp)
+{
+  struct rootfs_vdata *rvd;
+
+  mtx_lock(&rootfs_vncache_mutex);
+  rvd = (struct rootfs_vdata *)vp->v_data;
+  KASSERT(rvd != NULL, ("rootfs_vncache_free(): no vnode data\n"));
+  if (rvd->rvd_next)
+    rvd->rvd_next->rvd_prev = rvd->rvd_prev;
+  if (rvd->rvd_prev) {
+    rvd->rvd_prev->rvd_next = rvd->rvd_next;
+  } else if (rootfs_vncache == rvd) {
+    rootfs_vncache = rvd->rvd_next;
+  }
+  mtx_unlock(&rootfs_vncache_mutex);
+  free(rvd, M_ROOTFSVNCACHE);
+  vp->v_data = NULL;
+  return (0);
+}
+
+
+static void
+pfs_purge(struct rootfs_node *rn)
+{
+  struct rootfs_vdata *rvd;
+  struct vnode *vnp;
+  mtx_lock(&rootfs_vncache_mutex);
+  rvd = rootfs_vncache;
+  while (rvd != NULL) {
+    if (rvd->rvd_dead || (rn != NULL && rvd->rvd_rn == rn)) {
+      vnp = rvd->rvd_vnode;
+      vhold(vnp);
+      mtx_unlock(&rootfs_vncache_mutex);
+      VOP_LOCK(vnp, LK_EXCLUSIVE);
+      vgone(vnp);
+      VOP_UNLOCK(vnp, 0);
+      mtx_lock(&rootfs_vncache_mutex);
+      vdrop(vnp);
+      rvd = rootfs_vncache;
+    } else {
+      rvd = rvd->rvd_next;
+    }
+  }
+  mtx_unlock(&rootfs_vncache_mutex);
+}
+
+
+/*
+ * Verify permissions
+ */
+static int
+rootfs_access(struct vop_access_args *va)
+{
+  struct vnode *vn = va->a_vp;
+  struct rootfs_node *rn = vn->v_data;
+  struct vattr vattr;
+  int error;
+
+  ROOTFS_TRACE(("%s", rn->rn_name));
+  (void)rn;
+
+  error = VOP_GETATTR(vn, &vattr, va->a_cred);
+  if (error)
+    ROOTFS_RETURN (error);
+  error = vaccess(vn->v_type, vattr.va_mode, vattr.va_uid,
+                  vattr.va_gid, va->a_accmode, va->a_cred, NULL);
+  ROOTFS_RETURN (error);
+}
+
+/*
+ * Get file attributes
+ */
+static int
+rootfs_getattr(struct vop_getattr_args *va)
+{
+  struct vnode *vn = va->a_vp;
+  struct rootfs_node *rn = vn->v_data;
+  struct vattr *vap = va->a_vap;
+  int error = 0;
+
+  ROOTFS_TRACE(("%s", rn->rn_name));
+  rootfs_assert_not_owned(rn);
+
+  vap->va_type = vn->v_type;
+  vap->va_fileid = alloc_unr(rootfs->ri_unrhdr);
+  vap->va_flags = 0;
+  vap->va_blocksize = PAGE_SIZE;
+  vap->va_bytes = vap->va_size = 0;
+  vap->va_filerev = 0;
+  vap->va_fsid = vn->v_mount->mnt_stat.f_fsid.val[0];
+  vap->va_nlink = 1;
+  nanotime(&vap->va_ctime);
+  vap->va_atime = vap->va_mtime = vap->va_ctime;
+
+  vap->va_mode = 0555;
+  vap->va_uid = 0;
+  vap->va_gid = 0;
+
+  ROOTFS_RETURN (error);
+}
+
+/*
+ * Make directory
+ */
+static int
+rootfs_mkdir(struct vop_mkdir_args *va)
+{
+  struct vnode *dvn = va->a_dvp;
+  struct vnode **vpp = va->a_vpp;
+  struct vattr *vap = va->a_vap;
+  struct rootfs_node *rn;
+  int error = 0;
+
+  ROOTFS_TRACE(("%s", rn->rn_name));
+
+  error = EOPNOTSUPP;
+
+  ROOTFS_RETURN (error);
+}
+
+/*
+ * Remove directory
+ */
+static int
+rootfs_rmdir(struct vop_rmdir_args *va)
+{
+  struct vnode *vn = va->a_vp;
+  struct rootfs_node *rn = vn->v_data;
+  int error = 0;
+
+  ROOTFS_TRACE(("%s", rn->rn_name));
+  rootfs_assert_not_owned(rn);
+
+  error = EOPNOTSUPP;
+
+  ROOTFS_RETURN (error);
+}
+
+/*
+ * Convert a vnode to its component name
+ */
+static int
+rootfs_vptocnp(struct vop_vptocnp_args *ap)
+{
+  struct vnode *vp = ap->a_vp;
+  struct vnode **dvp = ap->a_vpp;
+  struct rootfs_node *rn = vp->v_data;
+  struct mount *mp;
+  char *buf = ap->a_buf;
+  int *buflen = ap->a_buflen;
+  char pidbuf[ROOTFS_NAMELEN];
+  int len, i, error, locked;
+
+  i = *buflen;
+  error = 0;
+
+  rootfs_lock(rn);
+
+  if (vp->v_type == VDIR && ((rn->rn_flags & ROOTFS_ROOT) != 0)) {
+    *dvp = vp;
+    vhold(*dvp);
+    rootfs_unlock(rn);
+    ROOTFS_RETURN (0);
+  } else {
+    len = strlen(rn->rn_name);
+    i -= len;
+    if (i < 0) {
+      error = ENOMEM;
+      goto failed;
+    }
+    bcopy(rn->rn_name, buf + i, len);
+  }
+
+  rootfs_unlock(rn);
+  rn = rn->rn_parent;
+  rootfs_lock(rn);
+
+  mp = vp->v_mount;
+  error = vfs_busy(mp, 0);
+  if (error)
+    return (error);
+
+  /*
+   * vp is held by caller.
+   */
+  locked = VOP_ISLOCKED(vp);
+  VOP_UNLOCK(vp, 0);
+
+  *buflen = i;
+  VOP_UNLOCK(*dvp, 0);
+  vn_lock(vp, locked | LK_RETRY);
+  vfs_unbusy(mp);
+
+  ROOTFS_RETURN (0);
+failed:
+  rootfs_unlock(rn);
+  ROOTFS_RETURN(error);
+}
+
+/*
+ * Look up a file or directory
+ */
+static int
+rootfs_lookup(struct vop_cachedlookup_args *va)
+{
+  struct vnode *vn = va->a_dvp;
+  struct vnode **vpp = va->a_vpp;
+  struct componentname *cnp = va->a_cnp;
+  struct rootfs_node *rvn = vn->v_data;
+  struct rootfs_node *rn, *pdn = NULL;
+  struct mount *mp;
+  char *rname;
+  int error, i, namelen, visible;
+
+  ROOTFS_TRACE(("%.*s", (int)cnp->cn_namelen, cnp->cn_nameptr));
+  rootfs_assert_not_owned(rvn);
+
+  if (vn->v_type != VDIR)
+    ROOTFS_RETURN (ENOTDIR);
+
+  if ((cnp->cn_flags & ISLASTCN) && cnp->cn_nameiop == RENAME)
+    ROOTFS_RETURN (EOPNOTSUPP);
+
+  /* shortcut: check if the name is too long */
+  if (cnp->cn_namelen >= ROOTFS_NAMELEN)
+    ROOTFS_RETURN (ENOENT);
+
+  /* self */
+  namelen = cnp->cn_namelen;
+  rname = cnp->cn_nameptr;
+  if (namelen == 1 && rname[0] == '.') {
+    *vpp = vn;
+    VREF(vn);
+    ROOTFS_RETURN (0);
+  }
+
+  mp = vn->v_mount;
+
+  /* parent */
+  if (cnp->cn_flags & ISDOTDOT) {
+    if (rvn->rn_flags & ROOTFS_ROOT)
+      ROOTFS_RETURN (EIO);
+    error = vfs_busy(mp, MBF_NOWAIT);
+    if (error != 0) {
+      vfs_ref(mp);
+      VOP_UNLOCK(vn, 0);
+      error = vfs_busy(mp, 0);
+      vn_lock(vn, LK_EXCLUSIVE | LK_RETRY);
+      vfs_rel(mp);
+      if (error != 0)
+        ROOTFS_RETURN(ENOENT);
+      if (vn->v_iflag & VI_DOOMED) {
+        vfs_unbusy(mp);
+        ROOTFS_RETURN(ENOENT);
+      }
+    }
+    VOP_UNLOCK(vn, 0);
+    rootfs_lock(rvn);
+    rn = rvn->rn_parent;
+    rootfs_unlock(rvn);
+    goto got_rnode;
+  }
+
+  rootfs_lock(rvn);
+
+  /* named node */
+  for (rn = rvn->rn_children; rn != NULL; rn = rn->rn_next) {
+    if (rn->rn_name[namelen] == '\0' &&
+        bcmp(rname, rn->rn_name, namelen) == 0) {
+      rootfs_unlock(rvn);
+      goto got_rnode;
+    }
+  }
+
+  rootfs_unlock(rvn);
+
+  ROOTFS_RETURN (ENOENT);
+got_rnode:
+  rootfs_assert_not_owned(rvn);
+  rootfs_assert_not_owned(rn);
+  error = rootfs_vncache_alloc(mp, vpp, rn);
+  if (error)
+    goto failed;
+  if (cnp->cn_flags & ISDOTDOT) {
+    vfs_unbusy(mp);
+    vn_lock(vn, LK_EXCLUSIVE | LK_RETRY);
+    if (vn->v_iflag & VI_DOOMED) {
+      vput(*vpp);
+      *vpp = NULL;
+      ROOTFS_RETURN(ENOENT);
+    }
+  }
+  if (cnp->cn_flags & MAKEENTRY && !(vn->v_iflag & VI_DOOMED))
+    cache_enter(vn, *vpp, cnp);
+  ROOTFS_RETURN (0);
+failed:
+  if (cnp->cn_flags & ISDOTDOT) {
+    vfs_unbusy(mp);
+    vn_lock(vn, LK_EXCLUSIVE | LK_RETRY);
+    *vpp = NULL;
+  }
+  ROOTFS_RETURN(error);
+}
+
+static int
+rootfs_init(struct vfsconf *vfsp)
+{
+  printf("rootfs: init\n");
+  return (0);
+}
+
+static int
+rootfs_mount(struct mount *mp)
+{
+  printf("rootfs: mount\n");
+  return (0);
+}
+
+static int
+rootfs_cmount(struct mntarg *ma, void *data, uint64_t flags)
+{
+  printf("rootfs: cmount\n");
+  return (0);
+}
+
+static int
+rootfs_root(struct mount *mp, int flags, struct vnode **vpp)
+{
+  *vpp = rootfs->ri_root->rn_vnode;
+  return (0);
+}
+
+static int
+rootfs_statfs(struct mount *mp, struct statfs *sbp)
+{
+  printf("rootfs: statfs\n");
+  return (0);
+}
+
+static int
+rootfs_sync(struct mount *mp, int waitfor)
+{
+  return (0);
+}
+
+static int
+rootfs_uninit(struct vfsconf *vfsp)
+{
+  printf("rootfs: uninit\n");
+  return (EOPNOTSUPP);
+}
+
+static int
+nfs_unmount(struct mount *mp, int mntflags)
+{
+  printf("rootfs: unmount\n");
+  return (EOPNOTSUPP);
+}
+
+static int
+rootfs_sysctl(struct mount *mp, fsctlop_t op, struct sysctl_req *req)
+{
+  return (0);
+}
+
+static void
+rootfs_purge(struct mount *mp)
+{
+}
+
+static int
+rootfs_modevent(module_t mod, int type, void *data)
+{
+  int error = 0;
+  static int loaded = 0;
+  switch (type) {
+  case MOD_LOAD:
+    if (loaded)
+      return (0);
+    mtx_init(&rootfs_vncache_mutex, "rootds_vncache_mutex", NULL, MTX_DEF);
+    loaded = 1;
+    break;
+  case MOD_UNLOAD:
+    error = EBUSY;
+    break;
+  default:
+    error = EOPNOTSUPP;
+    break;
+  }
+  return error;
+}
+static moduledata_t rootfs_mod = {
+	"rootfs",
+	rootfs_modevent,
+	NULL,
+};
+DECLARE_MODULE(rootfs, rootfs_mod, SI_SUB_VFS, SI_ORDER_FIRST);
+MODULE_VERSION(rootfs, 1);
